function varargout = MobileEMG(varargin)
% MOBILEEMG M-file for MobileEMG.fig
%      MOBILEEMG, by itself, creates a new MOBILEEMG or raises the existing
%      singleton*.
%
%      H = MOBILEEMG returns the handle to a new MOBILEEMG or the handle to
%      the existing singleton*.
%
%      MOBILEEMG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MOBILEEMG.M with the given input arguments.
%
%      MOBILEEMG('Property','Value',...) creates a new MOBILEEMG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before MobileEMG_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to MobileEMG_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MobileEMG

% Last Modified by GUIDE v2.5 25-Apr-2009 15:03:04

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @MobileEMG_OpeningFcn, ...
    'gui_OutputFcn',  @MobileEMG_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before MobileEMG is made visible.
function MobileEMG_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to MobileEMG (see VARARGIN)

% Choose default command line output for MobileEMG
handles.output = hObject;

%%Initialize useful variables: 
handles.baudRate = 2400;
handles.packetSize = 30;
handles.numChannels = 1;

handles.serialtime = now;% setup timestamp
handles.maxSampleTime = 120;
handles.minSampleTime = 5;
handles.sampleTime = handles.minSampleTime;
handles.sampleRate = 100;%sampleRate of 100 Hz
handles.VDC = 0;
handles.Vpp = 0;
handles.Vref = 5;
handles.Gain = 150;
handles.avgnum = 7;
handles.t = 1/handles.sampleRate:1/handles.sampleRate:handles.minSampleTime;
handles.data = zeros(handles.sampleRate*handles.sampleTime);
handles.datahp = handles.data;
handles.datarect = handles.data;
handles.datatimeavg = handles.data;
handles.filename = '';% default filename... nothing special
handles.running = false;%we are not running serial communications

% This sets up the initial plot - only do when we are invisible
% so window can get raised using MobileEMG.
if strcmp(get(hObject,'Visible'),'off')
    pushbutton1_Callback(hObject,eventdata,handles);
end

set(handles.text6, 'String', handles.sampleTime);
set(hObject,'toolbar','figure');
% UIWAIT makes MobileEMG wait for user response (see UIRESUME)
% uiwait(handles.figure1);
% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = MobileEMG_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in pushbutton1.
%Push button 1 is the update function. We should graph our current data
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axes1);
cla;
popup_sel_index = get(handles.popupmenu1, 'Value');
set(handles.text23, 'String', datestr(handles.serialtime));%the time
if (handles.numChannels == 1)
    switch popup_sel_index
        case 1
            plot(handles.t,handles.data);
            axis([handles.t(1) handles.t(max(size(handles.data))) 0 handles.Vref]);
            set(gca,'FontSize',14);
            title('Raw EMG data');
            set(gca,'FontSize',8);
            ylabel('Voltage [V]');
        case 2
            plot(handles.t(15:length(handles.t)),handles.datahp(15:length(handles.datahp))/handles.Gain*1000);
            axis([handles.t(1) handles.t(max(size(handles.data))) -handles.Vref/2/handles.Gain*1000 handles.Vref/2/handles.Gain*1000]);
            set(gca,'FontSize',14);
            title('High Pass Filtered data');
            set(gca,'FontSize',8);
            ylabel('Voltage [mV]');
        case 3
            plot(handles.t(15:length(handles.t)),handles.datarect(15:length(handles.t))/handles.Gain*1000);
            axis([handles.t(1) handles.t(max(size(handles.data))) 0 handles.Vref/2/handles.Gain*1000]);
            set(gca,'FontSize',14);
            title('Rectified data');
            set(gca,'FontSize',8);
            ylabel('Voltage [mV]');
        case 4
            plot(handles.t(16:length(handles.t)),...
                handles.datatimeavg(16:length(handles.t))/handles.Gain*1000);
            axis([handles.t(1) handles.t(max(size(handles.data))) 0 handles.Vref/2/handles.Gain*1000]);
            set(gca,'FontSize',14);
            title('Time Averaged data');
            set(gca,'FontSize',8);
            ylabel('Voltage [mV]');
    end
elseif (handles.numChannels ==2)
    switch popup_sel_index
        case 1
            plot(handles.t,handles.data(1,:),'b-',handles.t,handles.data(2,:),'r-');
            axis([handles.t(1) handles.t(max(size(handles.data))) 0 handles.Vref]);
            set(gca,'FontSize',14);
            title('Raw EMG data');
            set(gca,'FontSize',8);
            ylabel('Voltage [V]');
        case 2
            plot(handles.t(15:length(handles.t)),handles.datahp(1,15:length(handles.datahp))/handles.Gain*1000,'b-',...
                 handles.t(15:length(handles.t)),handles.datahp(2,15:length(handles.datahp))/handles.Gain*1000,'r-');
            axis([handles.t(1) handles.t(max(size(handles.data))) -handles.Vref/2/handles.Gain*1000 handles.Vref/2/handles.Gain*1000]);
            set(gca,'FontSize',14);
            title('High Pass Filtered data');
            set(gca,'FontSize',8);
            ylabel('Voltage [mV]');
        case 3
            plot(handles.t(15:length(handles.t)),handles.datarect(1,15:length(handles.t))/handles.Gain*1000,'b-',...
                 handles.t(15:length(handles.t)),handles.datarect(2,15:length(handles.t))/handles.Gain*1000,'r-');
            axis([handles.t(1) handles.t(max(size(handles.data))) 0 handles.Vref/2/handles.Gain*1000]);
            set(gca,'FontSize',14);
            title('Rectified data');
            set(gca,'FontSize',8);
            ylabel('Voltage [mV]');
        case 4
            plot(handles.t(16:length(handles.t)),handles.datatimeavg(1,16:length(handles.t))/handles.Gain*1000,'b-',...
                 handles.t(16:length(handles.t)),handles.datatimeavg(2,16:length(handles.t))/handles.Gain*1000,'r-');
            axis([handles.t(1) handles.t(max(size(handles.data))) 0 handles.Vref/2/handles.Gain*1000]);
            set(gca,'FontSize',14);
            title('Time Averaged data');
            set(gca,'FontSize',8);
            ylabel('Voltage [mV]');
    end
end

xlabel('time [s]');

grid;


%**********************NOT USED******************************************
% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)

% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject, 'String', {'Raw Data', 'High Pass', 'Rectified', 'Time Averaged'});
%********************END NOT USED*****************************************

%
% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
% Slider sets the sample time
handles.sampleTime = floor(get(hObject,'Value')*handles.maxSampleTime+handles.minSampleTime);
guidata(hObject,handles);
set(handles.text6, 'String', handles.sampleTime);


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double
handles.filename = get(hObject,'String');% save the filename
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%handles.filename = get(handles.edit3,'String');
handles.filename = get(handles.edit3,'String');
set(handles.text13,'String',handles.filename);
handles = save_data(handles);
guidata(hObject,handles);

% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.filename = get(handles.edit3,'String');
[handles.data handles.serialtime handles.numChannels] = load_data(handles.filename,handles.sampleRate);
handles = format_data(handles);%format the data we have received
handles = filter_data(handles);% filters the data
%pushbutton1_Callback(hObject, eventdata, handles);%immediately plot data
%update the handles structure
set(handles.text13, 'String', handles.filename);
guidata(hObject, handles);
pushbutton1_Callback(hObject,eventdata,handles);%update graph


% --- Executes on button press in togglebutton5
function togglebutton5_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton3
%If the toggle button is pushed....
if (get(hObject,'Value') == 1)
    set(hObject,'BackgroundColor',[1 0 0])
    set(hObject,'String','Stop');
    assignin('base','running',true);
    %We are now running
    %uses base workspace so that the variable can be seen from inside
    %SerialIn
    handles = SerialIn(handles,hObject);
    
else
    set(hObject,'BackgroundColor',[0 .502 0])
    set(hObject,'String','Start');
    assignin('base','running',false);
end
guidata(hObject,handles);





