function handles = SerialIn(handles,hObject)
if (isempty(instrfind) == 0)% close stray used ports
    fclose(instrfind);
    delete(instrfind);
end

header = 0;%keep track of start
numChan = 0;%keep track of packet channelNum
bytesLost = 0;%keep track of lost packets



s = serial('COM1','Baudrate',handles.baudRate);
set(s, 'InputBufferSize', 2048);
set(s, 'OutputBufferSize', 2048);
fopen(s);
readasync(s);

exit = false;
handles.running = true;
waiting = 0;
disp('starting');% just starting


%Syncs up and discards first packet received
while (~exit&&evalin('base','running')==true)
    if( s.bytesAvailable > 1 )
        header = fread(s,1,'uint8');
        if (header == 255)
            handles.numChannels = fread(s,1,'uint8');
            fread(s,1,'uint8');%we don't care about how many lost...
            %gets rid of 30 so we start at the beginning of next packet
            fread(s,handles.packetSize);
            exit = true;
        end
    else
        pause(.001);
        waiting = waiting + 1;
        if (waiting > 1000)
            assignin('base','running',false);
        end
    end
end


if ((evalin('base','running') == true) &&(handles.numChannels==1||handles.numChannels==2))
    % if we didn't quit...
    handles.sampleRate = 100/handles.numChannels;
    handles.sampleTime = floor(get(handles.slider2,'Value')*handles.maxSampleTime+handles.minSampleTime);

    handles.numSamples = handles.sampleTime*handles.sampleRate;
    
    %initializing data
    handles.data = zeros(handles.numChannels,handles.numSamples);
    handles.datahp = handles.data;
    handles.datarect = handles.data;
    handles.datatimeavg = handles.data;
    handles.t = 1/handles.sampleRate:1/handles.sampleRate:handles.numSamples/handles.sampleRate;
    %now that handles and data and t are set up...
    cla;
    plot(handles.t,handles.data);%set up our plot

    n = 1;
    waiting = 0;
    set(handles.text13, 'String', 'New Data');%tell user that current data is not saved
    handles.serialtime = now;
    tic
    while (n<=handles.numSamples && evalin('base','running') == true)

        if (s.bytesAvailable >= handles.packetSize + 3)
            waiting = 0;
            header = fread(s,1);%should be 255
            numChan = fread(s,1);%should be numChannels
            bytesLost = 30*(fread(s,1)-1);%should be 0...
            disp('handles.bytesLost: ');
            bytesLost
            if (header==255 && numChan == handles.numChannels)%no problems else...we have a problem unsynced...quit
                %we should fill lost bytes with just 0... or if available
                %the last value we encountered
                if (bytesLost > 0)
                    disp('oops');
                    if (handles.numChannels == 1)
                        if (n  == 0)
                            replacementData = handles.Vref/2;
                        else
                            replacementData = handles.data(n-1);
                        end
                        for k = n:n+(bytesLost-1)
                            handles.data(k) = replacementData;
                        end
                        n = n + bytesLost;
                    elseif(handles.numChannels == 2)
                        if (n  == 0)
                            replacementData = [handles.Vref/2; handles.Vref/2];
                        else
                            replacementData = handles.data(:,(n-1));
                        end
                        for k = n:(n:n+floor(bytesLost/2)-1)
                            handles.data(:,k) = replacementData;
                        end
                        n = n+floor(bytesLost/2);
                    end
                end
                
                bytesToRead = handles.packetSize;
                if (bytesToRead/handles.numChannels + n > handles.numSamples)
                    bytesToRead = (handles.numSamples +1 - n)*handles.numChannels;
                end
                if (bytesToRead > 0 )%that means we actually have bytes to read...
                    temp =  fread(s,bytesToRead,'uint8');
                    if (handles.numChannels == 2)
                        odd  = 1:2:bytesToRead;
                        even = 2:2:bytesToRead;

                        handles.data(1,n:(n+floor(bytesToRead/2)-1)) = temp(odd)/255*handles.Vref;
                        handles.data(2,n:(n+floor(bytesToRead/2)-1)) = temp(even)/255*handles.Vref;
                        
                        %refreshing the plot
                        plot(handles.t(1:(n+floor(bytesToRead/2)-1) ), handles.data( 1,1:(n+floor(bytesToRead/2)-1) ), 'b-'...
                            ,handles.t(1:(n+floor(bytesToRead/2)-1) ), handles.data( 2,1:(n+floor(bytesToRead/2)-1) ), 'r-');
                        axis([0 handles.numSamples/handles.sampleRate 0 handles.Vref]);
                        grid;
                        n = n + floor(bytesToRead/2);
                        if (floor(bytesToRead/2)==0)
                            n= n+4;%remove this...
                        end
                    else
                        handles.data(n:(n+(bytesToRead-1))) = temp/255*handles.Vref;
                        
                        plot(handles.t(1:(n+(bytesToRead-1))),handles.data(1:(n+(bytesToRead-1))),'b-');
                        axis([0 handles.numSamples/handles.sampleRate 0 handles.Vref]);
                        grid;
                        n = n + bytesToRead;
                    end
                end
            else
                assignin('base','running',false);%we are done here
            end
        else
            pause(.1);
            waiting = waiting + 1;
            if (waiting > 100)
                assignin('base','running',false);
            end
        end
    end
    telapsed = toc
    if (evalin('base','running') == true)
        %the user didn't quit...we should tell the user that the sim is done
        assignin('base','running',false);
    end

    %resizing data and t to fit what was actually recorded...
    handles.data = handles.data(:,1:handles.numSamples);
    handles.t = handles.t(1:handles.numSamples);
    handles.sampleTime = n/handles.sampleRate;
    set(hObject,'BackgroundColor',[0 .502 0])
    set(hObject,'String','Start');
    set(hObject,'Value',0);%not pressed....

    handles = format_data(handles);%format the data...
    handles = filter_data(handles);%filter the data

    if (handles.numChannels == 1)
        plot(handles.t,handles.data,'b-');
    elseif(handles.numChannels == 2)
        plot(handles.t,handles.data(1,:),'b-',handles.t,handles.data(2,:),'r-');
    end
    axis([handles.t(1) handles.t(max(size(handles.data))) 0 handles.Vref]);
    set(gca,'FontSize',14);
    title('Raw EMG data');
    set(gca,'FontSize',8);
    ylabel('Voltage [V]');
else
    assignin('base','running',false);
    set(hObject,'BackgroundColor',[0 .502 0])
    set(hObject,'String','Start');
    set(hObject,'Value',0);%not pressed....
end
fclose(s);
delete(s);
clear s;
