function [data time numChannels] = load_data(fileName,sampleRate)
%LOAD_DATA Loads data from EMG
%   loads in the data from an emg and forms a date and a time...
%   fread reads in as a column so that is why we have all these '...
s = dir(fileName);
filesize = s.bytes;%gets filesize

fid = fopen(fileName,'r');
time = fread(fid,1,'float64');%first time recorded all other times will be recorded offset
numChannels = fread(fid,1,'uint8');%the number of channels we have
size = fread(fid,1,'int32');%first size;

if (numChannels == 1)
    data = fread(fid,size,'float32')';% first data 
    
    
    while (ftell(fid)<filesize)
        x = etime(datevec(fread(fid,1,'float64')),datevec(time));%time offset
        fread(fid,1,'uint8');%1 or 2...depicts our number of channels...it should be 1
        %fill in zeros for missing data
        data = [data zeros(1,x*sampleRate)];
        size = fread(fid,1,'int32');%first size;
        data = [data fread(fid,size,'float32')'];
    end
else
    data(1,:) = fread(fid,size,'float32')';
    data(2,:) = fread(fid,size,'float32')';

    while (ftell(fid)<filesize)
        x = etime(datevec(fread(fid,1,'float64')),datevec(time));%time offset
        fread(fid,1,'uint8');%1 or 2...depicts our number of channels...it should be 1
        %fill in zeros for missing data
        data = [data(1,:) zeros(1,x*sampleRate/2);data(2,:) zeros(1,x*sampleRate/2)];
        size = fread(fid,1,'int32');%first size;
        data = [data(1,:) fread(fid,size,'float32')'; data(2,:) fread(fid,size,'float32')'];
    end
end

fclose(fid);
end